#SingleInstance force
#include CLR.ahk
polled_guids := 0
device_list := {}

asm := CLR_LoadLibrary("JoystickWrapper.dll")
jw := CLR_CreateObject(asm, "JWNameSpace.JoystickWrapper")

_device_list := jw.GetDevices()
Gui, Add, ListView, w300 h100 Checked hwndhDeviceSelect gDeviceSelected Altsubmit, Name|Guid
ct := _device_list.Length()
Loop % ct {
    dev := _device_list.GetIndex(A_Index - 1)
    LV_Add(, dev.Name, dev.Guid)
    device_list[dev.Guid] := dev.Name
}
LV_ModifyCol(1, 200)

Gui, Add, ListView, w300 h300 hwndhDeviceReports, Device|Input|Value
LV_ModifyCol(1, 100)
LV_ModifyCol(2, 100)
Gui, Show

Loop {
    if (IsObject(polled_guids)){
        for polled_guid, unused in polled_guids{
            state := jw.PollStick(polled_guid)
            rpt_ct := state.Length()
            Gui, ListView, % hDeviceReports
            Loop % rpt_ct {
                rpt := state.GetIndex(A_Index-1)
                row := LV_Add(,device_list[polled_guid], rpt.InputName, rpt.Value)
                LV_Modify(row, "vis")
                inp := rpt.InputName
            }
        }
    }
    Sleep 10
}
return

DeviceSelected:
    if (A_GuiEvent != "I")
        return
    Gui, ListView, % hDeviceSelect
    
    if (ErrorLevel = "c"){
        ; Check / Uncheck
        state := ErrorLevel == "C" ? 1 : 0
        LV_GetText(guid, A_EventInfo, 2)
        if (state){
            if (!IsObject(polled_guids))
                polled_guids := {}
            polled_guids[guid] := 1
        } else {
            if (ObjHasKey(polled_guids, guid)){
                polled_guids.Delete(guid)
                if (IsEmptyAssoc(polled_guids))
                    polled_guids := 0
            }
        }
    }
    return

IsEmptyAssoc(arr){
    for k, v in arr
        return 0
    return 1
}

GuiClose:
    ExitApp